local races = { }
races[   "blood elf"] = { raceTypes = {      "horde",                          "civilized",           "elven", "magic"              } }
races["death knight"] = { raceTypes = {                             "neutral"                                                       } }
races[     "draenei"] = { raceTypes = {               "alliance",                           "tribal"                                } }
races[       "dwarf"] = { raceTypes = {               "alliance",              "civilized"                                          } }
races[       "gnome"] = { raceTypes = {               "alliance",              "civilized",                    "magic"              } }
races[      "goblin"] = { raceTypes = {                             "neutral"                                                       } }
races[    "half elf"] = { raceTypes = {      "horde", "alliance",   "neutral", "civilized",           "elven", "magic", "halfbreed" } }
races[    "half orc"] = { raceTypes = {      "horde", "alliance",   "neutral", "civilized", "tribal",                   "halfbreed" } }
races[    "high elf"] = { raceTypes = {               "alliance",              "civilized",           "elven", "magic"              } }
races[       "human"] = { raceTypes = {               "alliance",              "civilized",                    "magic"              } }
races[   "night elf"] = { raceTypes = {               "alliance",              "civilized",           "elven"                       } }
races[         "orc"] = { raceTypes = {               "alliance",                           "tribal"                                } }
races[    "pandaren"] = { raceTypes = {      "horde", "alliance",   "neutral"                                                       } }
races[      "tauren"] = { raceTypes = {      "horde",                                       "tribal"                                } }
races[       "troll"] = { raceTypes = {      "horde",                                       "tribal"                                } }
races[      "undead"] = { raceTypes = {      "horde",                          "civilized"                                          } }
races[      "worgen"] = { raceTypes = {               "alliance",              "civilized"                                          } }

---------------------------------------------------------------------------------------------------------------------------------------
-- | Zone-based Generation | ----------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------
zonesToRaces = { }
-- Legion Zones
zonesToRaces[          "Dalaran"] = mergeTables(-- This works for both versions :D
	replicate( 1,      "blood elf"),
	replicate( 1,         "goblin"),
	replicate( 1,            "orc"),
	replicate( 1,         "tauren"),
	replicate( 1,          "troll"),
	replicate( 1,         "undead"),
  replicate( 1,        "draenei"),
	replicate( 1,          "dwarf"),
	replicate( 1,          "gnome"),
	replicate( 1,       "half elf"),
	replicate( 1,       "half orc"),
	replicate( 1,       "high elf"),
	replicate( 1,          "human"),
	replicate( 1,       "pandaren"),
	replicate( 1,      "night elf"),
	replicate( 1,         "worgen"))  
zonesToRaces[           "Azsuna"] = mergeTables(
	replicate( 1,      "blood elf"),
	replicate( 1,         "goblin"),
	replicate( 1,            "orc"),
	replicate( 1,         "tauren"),
	replicate( 1,          "troll"),
	replicate( 1,         "undead"),
  replicate( 1,        "draenei"),
	replicate( 1,          "dwarf"),
	replicate( 1,          "gnome"),
	replicate( 1,       "half elf"),
	replicate( 1,       "half orc"),
	replicate( 1,       "high elf"),
	replicate( 1,          "human"),
	replicate( 1,       "pandaren"),
	replicate( 1,      "night elf"),
	replicate( 1,         "worgen"))
zonesToRaces[     "Highmountain"] = mergeTables(
	replicate( 1,      "blood elf"),
	replicate( 1,         "goblin"),
	replicate( 1,            "orc"),
	replicate(30,         "tauren"),
	replicate( 1,          "troll"),
	replicate( 1,         "undead"),
  replicate( 1,        "draenei"),
	replicate( 1,          "dwarf"),
	replicate( 1,          "gnome"),
	replicate( 1,       "half elf"),
	replicate( 1,       "half orc"),
	replicate( 1,       "high elf"),
	replicate( 1,          "human"),
	replicate( 1,       "pandaren"),
	replicate( 1,      "night elf"),
	replicate( 1,         "worgen"))
zonesToRaces[    "Thunder Totem"] = mergeTables(  -- Yes, this counts as a separate zone. It should have higher amount of Tauren than the other parts of Highmountain.
	replicate( 1,      "blood elf"),
	replicate( 1,         "goblin"),
	replicate( 1,            "orc"),
	replicate(40,         "tauren"),
	replicate( 1,          "troll"),
	replicate( 1,         "undead"),
  replicate( 1,        "draenei"),
	replicate( 1,          "dwarf"),
	replicate( 1,          "gnome"),
	replicate( 1,       "half elf"),
	replicate( 1,       "half orc"),
	replicate( 1,       "high elf"),
	replicate( 1,          "human"),
	replicate( 1,       "pandaren"),
	replicate( 1,      "night elf"),
	replicate( 1,         "worgen"))
zonesToRaces[        "Stormheim"] = nil
zonesToRaces[          "Suramar"] = mergeTables(
	replicate(20,      "blood elf"),
	replicate( 1,         "goblin"),
	replicate( 1,            "orc"),
	replicate( 1,         "tauren"),
	replicate( 1,          "troll"),
	replicate( 1,         "undead"),
  replicate( 1,        "draenei"),
	replicate( 1,          "dwarf"),
	replicate( 1,          "gnome"),
	replicate( 1,       "half elf"),
	replicate( 1,       "half orc"),
	replicate(20,       "high elf"),
	replicate(10,          "human"),
	replicate( 1,       "pandaren"),
	replicate(30,      "night elf"),
	replicate( 1,         "worgen"))
zonesToRaces[       "Val'sharah"] = mergeTables(
	replicate( 1,      "blood elf"),
	replicate( 1,         "goblin"),
	replicate( 1,            "orc"),
	replicate( 5,         "tauren"),
	replicate( 1,          "troll"),
	replicate( 1,         "undead"),
  replicate( 1,        "draenei"),
	replicate( 1,          "dwarf"),
	replicate( 1,          "gnome"),
	replicate( 1,       "half elf"),
	replicate( 1,       "half orc"),
	replicate( 1,       "high elf"),
	replicate( 1,          "human"),
	replicate( 1,       "pandaren"),
	replicate(30,      "night elf"),
	replicate( 1,         "worgen"))
  
-- Horde Cities
zonesToRaces[  "Silvermoon City"] = mergeTables(
	replicate(21,      "blood elf"),
	replicate( 1,         "goblin"),
	replicate( 1,       "half elf"),
	replicate( 1,       "half orc"),
	replicate( 1,            "orc"),
	replicate( 1,       "pandaren"),
	replicate( 1,         "tauren"),
	replicate( 1,          "troll"),
	replicate( 2,         "undead"))
zonesToRaces[        "Orgrimmar"] = mergeTables(
	replicate( 1,      "blood elf"),
	replicate( 4,         "goblin"),
	replicate( 1,       "half elf"),
	replicate( 1,       "half orc"),
	replicate(22,            "orc"),
	replicate( 1,       "pandaren"),
	replicate( 3,         "tauren"),
	replicate( 4,          "troll"),
	replicate( 1,         "undead"))
zonesToRaces[    "Thunder Bluff"] = mergeTables(
	replicate( 1,      "blood elf"),
	replicate( 1,         "goblin"),
	replicate( 1,       "half elf"),
	replicate( 1,       "half orc"),
	replicate( 4,            "orc"),
	replicate( 1,       "pandaren"),
	replicate(19,         "tauren"),
	replicate( 1,          "troll"),
	replicate( 1,         "undead"))
zonesToRaces[        "Undercity"] = mergeTables(
	replicate( 2,      "blood elf"),
  replicate( 4,   "death knight"),
	replicate( 1,         "goblin"),
	replicate( 1,       "half elf"),
	replicate( 1,            "orc"),
	replicate( 1,       "pandaren"),
	replicate( 1,         "tauren"),
	replicate( 1,          "troll"),
	replicate(19,         "undead"))

-- Alliance Cities
zonesToRaces[   "Stormwind City"] = mergeTables(
  replicate( 1,        "draenei"),
	replicate( 5,          "dwarf"),
	replicate( 2,          "gnome"),
	replicate( 3,       "half elf"),
	replicate( 1,       "half orc"),
	replicate( 3,       "high elf"),
	replicate(20,          "human"),
	replicate( 1,       "pandaren"),
	replicate( 2,      "night elf"),
	replicate( 1,         "worgen"))
zonesToRaces[        "Darnassus"] = mergeTables(
  replicate( 4,        "draenei"),
	replicate( 1,          "dwarf"),
	replicate( 1,          "gnome"),
	replicate( 1,       "half elf"),
	replicate( 1,       "half orc"),
	replicate( 1,       "high elf"),
	replicate( 2,          "human"),
	replicate( 1,       "pandaren"),
	replicate(24,      "night elf"),
	replicate( 8,         "worgen"))
zonesToRaces["City of Ironforge"] = mergeTables(
  replicate( 1,        "draenei"),
	replicate(12,          "dwarf"),
	replicate( 6,          "gnome"),
	replicate( 1,       "half elf"),
	replicate( 1,       "half orc"),
	replicate( 1,       "high elf"),
	replicate( 4,          "human"),
	replicate( 1,       "pandaren"),
	replicate( 1,      "night elf"),
	replicate( 1,         "worgen"))
zonesToRaces[       "The Exodar"] = mergeTables(
  replicate(21,        "draenei"),
	replicate( 1,          "dwarf"),
	replicate( 1,          "gnome"),
	replicate( 1,       "half elf"),
	replicate( 1,       "half orc"),
	replicate( 1,       "high elf"),
	replicate( 1,          "human"),
	replicate( 1,       "pandaren"),
	replicate( 1,      "night elf"),
	replicate( 1,         "worgen"))

-- Neutral Hotspots
zonesToRaces[   "Shattrath City"] = nil

-- Horde Starting Zones (for now they are similar to the capitals next to them)
zonesToRaces[          "Durotar"] = zonesToRaces["Orgrimmar"]
zonesToRaces[   "Eversong Woods"] = zonesToRaces["Silvermoon City"]
zonesToRaces[       "Ghostlands"] = mergeTables(
  replicate(22,      "blood elf"),
	replicate( 1,         "goblin"),
	replicate( 2,       "half elf"),
	replicate( 1,       "half orc"),
	replicate( 1,            "orc"),
	replicate( 1,       "pandaren"),
	replicate( 1,         "tauren"),
	replicate( 1,          "troll"),
	replicate( 6,         "undead"))
zonesToRaces[          "Mulgore"] = zonesToRaces["Thunder Bluff"]
zonesToRaces[  "Sunstrider Isle"] = zonesToRaces["Eversong Woods"]
zonesToRaces[  "Tirisfal Glades"] = zonesToRaces["Undercity"]


-- Alliance Starting Zones (for now they are similar to the capitals next to them)
zonesToRaces[   "Azuremyst Isle"] = zonesToRaces["The Exodar"]
zonesToRaces[       "Dun Morogh"] = zonesToRaces["City of Ironforge"]
zonesToRaces[    "Elwynn Forest"] = zonesToRaces["Stormwind City"]
zonesToRaces[       "Teldrassil"] = zonesToRaces["Darnassus"]

--zonesToRaces[   "Shattrath City"] = nil

zonesToRaces[          "Default"] = keys(races) -- Will later be map(const(1), races)

---------------------------------------------------------------------------------------------------------------------------------------
-- | Subzone-based Generation | -------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------

subzonesToRaces = {
  ["Orgrimmar"] = {
    ["Valley of Honor"] = mergeTables(
      replicate(9, "orc"),
      replicate(3, "pandaren"),
      replicate(2, "goblin"),
      replicate(2, "tauren"),
      { "blood elf", "undead", "half elf", "half orc" }
    ),
  }
}

---------------------------------------------------------------------------------------------------------------------------------------
-- | Functions for Generation and Retrieval | -----------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------

-- generateRandomRace :: CharacterTemplate -> Race
function generateRandomRace(characterTemplate)
    local selectionList = 
      -- Subzone-based selection.
      ((subzonesToRaces[GetZoneText()] or { })[GetSubZoneText()])
      -- Zone-based selection.
      or zonesToRaces[GetZoneText()] 
      -- Default selection.
      or zonesToRaces["Default"]
  return randomFrom(selectionList or zonesToRaces["Default"])
	or "Error: No options found!"
end

-- allRacesExcept :: Race -> ... -> { Race }
function allRacesExcept(...)
  return without(keys(races), {...})
end

-- racesByType :: RaceType -> { Race }
function racesByType(raceType)
  return filterKeysByValue(
    function(x) return
      contains(raceType, x.raceTypes)
    end,
    eitherOr(raceType == "any", { }, races)
  )
end

-- racesByFaction :: UnitFactionGroup -> { Race }
function racesByFaction(faction)
  return racesByType(string.lower(faction))
end

function testZoneToRaceRatio()
  local test = { }
  log("Testing Zone to Race Ratio")
  forEach(
    function(x) 
      local result = generateRandomRace()
      test[result] = (test[result] or 0) + 1 end,
    replicate(10000, 1))
  logTableMapped(function(x) return x .. ", (" .. ((x / 10000) * 100) .. "%)" end, test)
end


-- End of File.