npcGenerator = { }

NPCG            = NPCG            or { }
NPCG.Events     = NPCG.Events     or { }
NPCG.Interface  = NPCG.Interface  or { }
--NPCG.Options    = NPCG.Options    or { }

local characterTemplates = { }

function GetCurrentCharacterTemplate()
  return characterTemplates[npcGenerator_NPC_Frame.Tabs.CurrentTab]
end

local function SaveNPC(i)
  if not nilOrWhitespace(characterTemplates[i]:getName()) then
    local npcName = characterTemplates[i]:getName()
    table.insert(savedNpcTemplates, characterTemplates[i]:clone())
    npcGenerator_NPC_Frame.Tabs.ContextFrame:Hide()
  else
    npcGenerator_NPC_Frame.HelperMessageFrame:AddMessage("The npcs needs a name to be saved.", 1.00, 0.05,0.05, 1.0)
  end
  --print "The npc is not well defined, some vital traits are lacking"
end

local function LoadNPC(n)
  local tabNumber = n
  
  local num_items       = table.getn(savedNpcTemplates)
  local items_per_page  = 4
  
  local frame = npcGenerator_Load_Frame
  
  local start = 1
  
  local action = function(i)
    local searchSpace = savedNpcTemplates
    
    if not nilOrWhitespaceOr(frame.SearchBox:GetText(), "Search for name, race, class...") then
      searchSpace = mergeTablesWithoutDuplicates(
        searchF(function(npc) return npc.name:lower()  end, frame.SearchBox:GetText():lower(), savedNpcTemplates),
        searchF(function(npc) return npc.race:lower()  end, frame.SearchBox:GetText():lower(), savedNpcTemplates),
        searchF(function(npc) return npc.class:lower() end, frame.SearchBox:GetText():lower(), savedNpcTemplates))
    end
    
    j = i % items_per_page
    if j == 0 then j = items_per_page end
    
    frame["Item" .. j].ItemName:SetText(     ucWords((searchSpace[i] or { name ="Empty" }).name))
    frame["Item" .. j].ItemRace:SetText(     ucWords((searchSpace[i] or { race =""      }).race))
    frame["Item" .. j].ItemClass:SetText(    ucWords((searchSpace[i] or { class=""      }).class))
    if searchSpace[i] then
      frame["Item" .. j .. "Button"]:SetScript("OnClick", function() 
        characterTemplates[n] = CharacterTemplate:new()
        characterTemplates[n]:setName(         searchSpace[i].name)
        characterTemplates[n]:setRace(         searchSpace[i].race)
        characterTemplates[n]:setTribe(        searchSpace[i].tribe)
        characterTemplates[n]:setGender(       searchSpace[i].gender)
        characterTemplates[n]:setAge(          searchSpace[i].age)
        characterTemplates[n]:setAlignment(    searchSpace[i].alignment)
        characterTemplates[n]:setFaith(        searchSpace[i].faith)
        characterTemplates[n]:setClass(        searchSpace[i].class)
        characterTemplates[n]:setFeature(      searchSpace[i].feature)
        characterTemplates[n]:setMotivation(1, searchSpace[i].motivations[1])
        characterTemplates[n]:setMotivation(2, searchSpace[i].motivations[2])
        characterTemplates[n]:setMotivation(3, searchSpace[i].motivations[3])
        
        npcGenerator_NPC_Frame["Tabs"]["SetTab"](n)
        
        frame:Hide()
      end)
    else
      frame["Item" .. j .. "Button"]:SetScript("OnClick", function() end)
    end
  end
  
  frame.SearchBox:SetScript("OnTextChanged", function()
    iterate(action, 1, 1 + items_per_page - 1)
  end)
  
  --iterate(action, start, start + items_per_page - 1)
  frame.NavigationBar.NumberBox:SetScript("OnTextChanged", function()
    local start = 1 + (frame.NavigationBar.NumberBox:GetNumber() - 1) * items_per_page
    
    local searchSpace = savedNpcTemplates
    
    if not nilOrWhitespaceOr(frame.SearchBox:GetText(), "Search for name, race, class...") then
      searchSpace = mergeTablesWithoutDuplicates(
        searchF(function(npc) return npc.name:lower()  end, frame.SearchBox:GetText():lower(), savedNpcTemplates),
        searchF(function(npc) return npc.race:lower()  end, frame.SearchBox:GetText():lower(), savedNpcTemplates),
        searchF(function(npc) return npc.class:lower() end, frame.SearchBox:GetText():lower(), savedNpcTemplates))
    end
    
    if table.getn(searchSpace) < start then
      local max_pages_needed = math.floor(table.getn(searchSpace) / 4)
      --frame.NavigationBar.NumberBox:GetNumber() - 1
      
      frame.NavigationBar.NumberBox:SetNumber(max_pages_needed)
    else
      iterate(action, start, start + items_per_page - 1)
    end
  end)
  
  frame:Show()
  --npcGenerator_NPC_Frame.HelperMessageFrame:AddMessage("Click an npc to load it")
  npcGenerator_NPC_Frame.Tabs.ContextFrame:Hide()
end

function npcGenerator.OnLoad()
  print "Hello, this is your pocket gnome kindly asking you to report npcGenerator issues to our issue tracker at https://wow.curseforge.com/projects/npcgenerator/issues"
  table.insert(characterTemplates, CharacterTemplate:new())
  
  local frame = npcGenerator_NPC_Frame
  
  -- Set up the Labels correctly.
  frame.Title.Label:SetText(       "npcGenerator 1.1.3")
  frame.Name.Label:SetText(        "Name")
  frame.Race.Label:SetText(        "Race")
  frame.Tribe.Label:SetText(       "Tribe")
  frame.Gender.Label:SetText(      "Gender")
  frame.Age.Label:SetText(         "Age")
  frame.Alignment.Label:SetText(   "Alignment")
  frame.Faith.Label:SetText(       "Faith")
  frame.Class.Label:SetText(       "Class")
  frame.Feature.Label:SetText(     "Prominent Feature")
  frame.Motivations.Label:SetText( "Motivations")
  
  -- Hook up events.
  
  -- OnChar scripts to load to characterTemplate.
  frame.Name.EditBox:SetScript(         "OnChar", readName)
  frame.Race.EditBox:SetScript(         "OnChar", readRace)
  frame.Tribe.EditBox:SetScript(        "OnChar", readTribe)
  frame.Gender.EditBox:SetScript(       "OnChar", readGender)
  frame.Age.EditBox:SetScript(          "OnChar", readAge)
  frame.Alignment.EditBox:SetScript(    "OnChar", readAlignment)
  frame.Faith.EditBox:SetScript(        "OnChar", readFaith)
  frame.Class.EditBox:SetScript(        "OnChar", readClass)
  frame.Feature.EditBox:SetScript(      "OnChar", readFeature)
  frame.Motivations.EditBox1:SetScript( "OnChar", function() readMotivation(1) end)
  frame.Motivations.EditBox2:SetScript( "OnChar", function() readMotivation(2) end)
  frame.Motivations.EditBox3:SetScript( "OnChar", function() readMotivation(3) end)
  
  -- OnClick scripts to reroll traits.
  frame.Name.RollButton:SetScript(         "OnClick", rollName)
  frame.Race.RollButton:SetScript(         "OnClick", rollRace)
  frame.Tribe.RollButton:SetScript(        "OnClick", rollTribe)
  frame.Gender.RollButton:SetScript(       "OnClick", rollGender)
  frame.Age.RollButton:SetScript(          "OnClick", rollAge)
  frame.Alignment.RollButton:SetScript(    "OnClick", rollAlignment)
  frame.Faith.RollButton:SetScript(        "OnClick", rollFaith)
  frame.Class.RollButton:SetScript(        "OnClick", rollClass)
  frame.Feature.RollButton:SetScript(      "OnClick", rollFeature)
  frame.Motivations.RollButton1:SetScript( "OnClick", function() rollMotivation(1) end )
  frame.Motivations.RollButton2:SetScript( "OnClick", function() rollMotivation(2) end )
  frame.Motivations.RollButton3:SetScript( "OnClick", function() rollMotivation(3) end )
  
  -- OnClick scripts to clear traits.
  frame.Name.ClearButton:SetScript(         "OnClick", clearName)
  frame.Race.ClearButton:SetScript(         "OnClick", clearRace)
  frame.Tribe.ClearButton:SetScript(        "OnClick", clearTribe)
  frame.Gender.ClearButton:SetScript(       "OnClick", clearGender)
  frame.Age.ClearButton:SetScript(          "OnClick", clearAge)
  frame.Alignment.ClearButton:SetScript(    "OnClick", clearAlignment)
  frame.Faith.ClearButton:SetScript(        "OnClick", clearFaith)
  frame.Class.ClearButton:SetScript(        "OnClick", clearClass)
  frame.Feature.ClearButton:SetScript(      "OnClick", clearFeature)
  frame.Motivations.ClearButton1:SetScript( "OnClick", function() clearMotivation(1) end )
  frame.Motivations.ClearButton2:SetScript( "OnClick", function() clearMotivation(2) end )
  frame.Motivations.ClearButton3:SetScript( "OnClick", function() clearMotivation(3) end )
  
  -- Hover messages
  local helperLabel = frame.HelperMessageFrame
  frame.Name.RollButton:SetScript(        "OnEnter", function() helperLabel:AddMessage("Generate a new name")        end)
  frame.Race.RollButton:SetScript(        "OnEnter", function() helperLabel:AddMessage("Generate a new race")        end)
  frame.Tribe.RollButton:SetScript(       "OnEnter", function() helperLabel:AddMessage("Generate a new tribe")       end)
  frame.Gender.RollButton:SetScript(      "OnEnter", function() helperLabel:AddMessage("Generate a new gender")      end)
  frame.Age.RollButton:SetScript(         "OnEnter", function() helperLabel:AddMessage("Generate a new age")         end)
  frame.Alignment.RollButton:SetScript(   "OnEnter", function() helperLabel:AddMessage("Generate a new alignment")   end)
  frame.Faith.RollButton:SetScript(       "OnEnter", function() helperLabel:AddMessage("Generate a new faith")       end)
  frame.Class.RollButton:SetScript(       "OnEnter", function() helperLabel:AddMessage("Generate a new class")       end)
  frame.Feature.RollButton:SetScript(     "OnEnter", function() helperLabel:AddMessage("Generate a new feature")     end)
  frame.Motivations.RollButton1:SetScript("OnEnter", function() helperLabel:AddMessage("Generate a new motivation")  end)
  frame.Motivations.RollButton2:SetScript("OnEnter", function() helperLabel:AddMessage("Generate a new motivation")  end)
  frame.Motivations.RollButton3:SetScript("OnEnter", function() helperLabel:AddMessage("Generate a new motivation")  end)
  
  frame.Name.ClearButton:SetScript(        "OnEnter", function() helperLabel:AddMessage("Clear the name")        end)
  frame.Race.ClearButton:SetScript(        "OnEnter", function() helperLabel:AddMessage("Clear the race")        end)
  frame.Tribe.ClearButton:SetScript(       "OnEnter", function() helperLabel:AddMessage("Clear the tribe")       end)
  frame.Gender.ClearButton:SetScript(      "OnEnter", function() helperLabel:AddMessage("Clear the gender")      end)
  frame.Age.ClearButton:SetScript(         "OnEnter", function() helperLabel:AddMessage("Clear the age")         end)
  frame.Alignment.ClearButton:SetScript(   "OnEnter", function() helperLabel:AddMessage("Clear the alignment")   end)
  frame.Faith.ClearButton:SetScript(       "OnEnter", function() helperLabel:AddMessage("Clear the faith")       end)
  frame.Class.ClearButton:SetScript(       "OnEnter", function() helperLabel:AddMessage("Clear the class")       end)
  frame.Feature.ClearButton:SetScript(     "OnEnter", function() helperLabel:AddMessage("Clear the feature")     end)
  frame.Motivations.ClearButton1:SetScript("OnEnter", function() helperLabel:AddMessage("Clear the motivation")  end)
  frame.Motivations.ClearButton2:SetScript("OnEnter", function() helperLabel:AddMessage("Clear the motivation")  end)
  frame.Motivations.ClearButton3:SetScript("OnEnter", function() helperLabel:AddMessage("Clear the motivation")  end)
  
  frame.Name:SetScript(        "OnEnter", function() helperLabel:AddMessage("The name for the npc")        end)
  frame.Race:SetScript(        "OnEnter", function() helperLabel:AddMessage("The race of the npc")         end)
  frame.Tribe:SetScript(       "OnEnter", function() helperLabel:AddMessage("The tribe the npc belongs to")end)
  frame.Gender:SetScript(      "OnEnter", function() helperLabel:AddMessage("The npc's gender")            end)
  frame.Age:SetScript(         "OnEnter", function() helperLabel:AddMessage("How old the npc is")          end)
  frame.Alignment:SetScript(   "OnEnter", function() helperLabel:AddMessage("Alignment for the npc")       end)
  frame.Faith:SetScript(       "OnEnter", function() helperLabel:AddMessage("The beliefs of the npc")      end)
  frame.Class:SetScript(       "OnEnter", function() helperLabel:AddMessage("A class for the npc, not just ingame class") end)
  frame.Feature:SetScript(     "OnEnter", function() helperLabel:AddMessage("What immediately stands out, similar to \"currently\"")     end)
  frame.Motivations:SetScript( "OnEnter", function() helperLabel:AddMessage("What drives the npc")       end)
  
  -- Hook onto Tab Changes.
  -- frame.Tabs.OnTabAdded is protected! Awyzuu set up events to overwrite and npcFrame.xml uses this...
  frame.Tabs.OnTabChanged = function(tabIndex)
    if tabIndex > table.getn(characterTemplates) then -- Workaround for the above.  
      table.insert(characterTemplates, CharacterTemplate:new())
    end
    printToFrame(characterTemplates[tabIndex]) 
    end
  frame.Tabs.OnTabRemoved = function(tabIndex)
    table.remove(characterTemplates, tabIndex)
  end

  frame.Tabs.ContextFrame:SetScript("OnShow", function(self)
    local ContextFrameTitle = ""
    if nilOrWhitespace(characterTemplates[self.GetTabIndex()]:getName()) then
      ContextFrameTitle = "Unamed npc " .. self.GetTabIndex()
    else
      ContextFrameTitle = characterTemplates[self.GetTabIndex()]:getName()
    end
    
    self["Label"]:SetText(ucWords(ContextFrameTitle))
  end)
  
  frame.Tabs.ContextFrame.LoadButton:SetScript("OnClick", function()
    LoadNPC(frame.Tabs.ContextFrame:GetTabIndex())
  end)
  
  frame.Tabs.ContextFrame.SaveButton:SetScript("OnClick", function()
    SaveNPC(frame.Tabs.ContextFrame:GetTabIndex())
  end)

  frame:HookScript("OnShow", function() frame.HelperMessageFrame:AddMessage("Press Generate to make an npc") end)
end

function NPCG.Events.OnAddonLoad()
  if savedNpcTemplates == nil then
    savedNpcTemplates = { }
  end
  if NPCG_Options == nil then
    NPCG_Options = { debug="false", forceFaction="false", safeMode="false" }
  end
  --NPCG.Options = NPCG_Options
  NPCG.LoadOptions()
end

function NPCG.Events.OnAddonUnload()
  
end

local eventFrame = CreateFrame("FRAME")

eventFrame:RegisterEvent("ADDON_LOADED")
eventFrame:RegisterEvent("PLAYER_LOGOUT")

function eventFrame.OnEvent(unusedArg, event, name)
  if name == "npcGenerator" then
    if     event == "ADDON_LOADED"  then NPCG.Events.OnAddonLoad()
    elseif event == "PLAYER_LOGOUT" then NPCG.Events.OnAddonUnload() end
  end
end
eventFrame:SetScript("OnEvent", eventFrame.OnEvent)
-- End of File.